X11-1.9: A binding to the X11 graphics library

Copyright | (c) Alastair Reid 1999-2003
License | BSD-style (see the file libraries/base/LICENSE)
Maintainer | libraries@haskell.org
Stability | provisional
Portability | portable
Safe Haskell | Safe
Language | Haskell98

Graphics.X11.Xlib.Types

Description

A collection of type declarations for interfacing with Xlib.

Synopsis

- newtype Display = Display (Ptr Display)
- newtype Screen = Screen (Ptr Screen)
- newtype Visual = Visual (Ptr Visual)
- newtype GC = GC (Ptr GC)
- data GCValues
- data SetWindowAttributes
- data VisualInfo = VisualInfo {
  - visualInfo_visual :: Visual
  - visualInfo_visualID :: VisualID
  - visualInfo_screen :: ScreenNumber
  - visualInfo_depth :: CInt
  - visualInfo_class :: CInt
  - visualInfo_redMask :: CULong
  - visualInfo_greenMask :: CULong
  - visualInfo_blueMask :: CULong
  - visualInfo_colormapSize :: CInt
  - visualInfo_bitsPerRGB :: CInt
  }
- newtype Image = Image (Ptr Image)
- data Point = Point {
  - pt_x :: !Position
  - pt_y :: !Position
  }
- data Rectangle = Rectangle {
  - rect_x :: !Position
  - rect_y :: !Position
  - rect_width :: !Dimension
  - rect_height :: !Dimension
  }
- data Arc = Arc {
  - arc_x :: Position
  - arc_y :: Position
  - arc_width :: Dimension
  - arc_height :: Dimension
  - arc_angle1 :: Angle
  - arc_angle2 :: Angle
  }
- data Segment = Segment {
  - seg_x1 :: Position
  - seg_y1 :: Position
  - seg_x2 :: Position
  - seg_y2 :: Position
  }
- data Color = Color {
  - color_pixel :: Pixel
  - color_red :: Word16
  - color_green :: Word16
  - color_blue :: Word16
  - color_flags :: Word8
  }
- type Pixel = Word64
- type Position = Int32
- type Dimension = Word32
- type Angle = CInt
- type ScreenNumber = Word32
- type Buffer = CInt

# Documentation

newtype Display Source #

pointer to an X11 `Display` structure

Constructors

Display (Ptr Display) |

Instances

Eq Display Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods (==) :: Display -> Display -> Bool Source # (/=) :: Display -> Display -> Bool Source #
Data Display Source # |

Instance details

Defined in Graphics.X11.Xlib.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> Display -> c Display Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c Display Source #

toConstr :: Display -> Constr Source #

dataTypeOf :: Display -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c Display) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c Display) Source #

gmapT :: (forall b. Data b => b -> b) -> Display -> Display Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> Display -> r Source #

gmapQr :: (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> Display -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> Display -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> Display -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> Display -> m Display Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> Display -> m Display Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> Display -> m Display Source #

Ord Display Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods compare :: Display -> Display -> Ordering Source # (<) :: Display -> Display -> Bool Source # (<=) :: Display -> Display -> Bool Source # (>) :: Display -> Display -> Bool Source # (>=) :: Display -> Display -> Bool Source # max :: Display -> Display -> Display Source # min :: Display -> Display -> Display Source #
Show Display Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods showsPrec :: Int -> Display -> ShowS Source # show :: Display -> String Source # showList :: [Display] -> ShowS Source #

newtype Screen Source #

pointer to an X11 `Screen` structure

Constructors

Screen (Ptr Screen) |

Instances

Eq Screen Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods (==) :: Screen -> Screen -> Bool Source # (/=) :: Screen -> Screen -> Bool Source #
Data Screen Source # |

Instance details

Defined in Graphics.X11.Xlib.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> Screen -> c Screen Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c Screen Source #

toConstr :: Screen -> Constr Source #

dataTypeOf :: Screen -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c Screen) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c Screen) Source #

gmapT :: (forall b. Data b => b -> b) -> Screen -> Screen Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> Screen -> r Source #

gmapQr :: (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> Screen -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> Screen -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> Screen -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> Screen -> m Screen Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> Screen -> m Screen Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> Screen -> m Screen Source #

Ord Screen Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods compare :: Screen -> Screen -> Ordering Source # (<) :: Screen -> Screen -> Bool Source # (<=) :: Screen -> Screen -> Bool Source # (>) :: Screen -> Screen -> Bool Source # (>=) :: Screen -> Screen -> Bool Source # max :: Screen -> Screen -> Screen Source # min :: Screen -> Screen -> Screen Source #
Show Screen Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods showsPrec :: Int -> Screen -> ShowS Source # show :: Screen -> String Source # showList :: [Screen] -> ShowS Source #

newtype Visual Source #

pointer to an X11 `Visual` structure

Constructors

Visual (Ptr Visual) |

Instances

Eq Visual Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods (==) :: Visual -> Visual -> Bool Source # (/=) :: Visual -> Visual -> Bool Source #
Data Visual Source # |

Instance details

Defined in Graphics.X11.Xlib.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> Visual -> c Visual Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c Visual Source #

toConstr :: Visual -> Constr Source #

dataTypeOf :: Visual -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c Visual) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c Visual) Source #

gmapT :: (forall b. Data b => b -> b) -> Visual -> Visual Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> Visual -> r Source #

gmapQr :: (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> Visual -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> Visual -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> Visual -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> Visual -> m Visual Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> Visual -> m Visual Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> Visual -> m Visual Source #

Ord Visual Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods compare :: Visual -> Visual -> Ordering Source # (<) :: Visual -> Visual -> Bool Source # (<=) :: Visual -> Visual -> Bool Source # (>) :: Visual -> Visual -> Bool Source # (>=) :: Visual -> Visual -> Bool Source # max :: Visual -> Visual -> Visual Source # min :: Visual -> Visual -> Visual Source #
Show Visual Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods showsPrec :: Int -> Visual -> ShowS Source # show :: Visual -> String Source # showList :: [Visual] -> ShowS Source #

newtype GC Source #

pointer to an X11 `GC` structure

Constructors

GC (Ptr GC) |

Instances

Eq GC Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods (==) :: GC -> GC -> Bool Source # (/=) :: GC -> GC -> Bool Source #
Data GC Source # |

Instance details

Defined in Graphics.X11.Xlib.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> GC -> c GC Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c GC Source #

toConstr :: GC -> Constr Source #

dataTypeOf :: GC -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c GC) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c GC) Source #

gmapT :: (forall b. Data b => b -> b) -> GC -> GC Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> GC -> r Source #

gmapQr :: (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> GC -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> GC -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> GC -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> GC -> m GC Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> GC -> m GC Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> GC -> m GC Source #

Ord GC Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods compare :: GC -> GC -> Ordering Source # (<) :: GC -> GC -> Bool Source # (<=) :: GC -> GC -> Bool Source # (>) :: GC -> GC -> Bool Source # (>=) :: GC -> GC -> Bool Source # max :: GC -> GC -> GC Source # min :: GC -> GC -> GC Source #
Show GC Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods showsPrec :: Int -> GC -> ShowS Source # show :: GC -> String Source # showList :: [GC] -> ShowS Source #

data GCValues Source #

pointer to an X11 `XGCValues` structure

Instances

Eq GCValues Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods (==) :: GCValues -> GCValues -> Bool Source # (/=) :: GCValues -> GCValues -> Bool Source #
Data GCValues Source # |

Instance details

Defined in Graphics.X11.Xlib.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> GCValues -> c GCValues Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c GCValues Source #

toConstr :: GCValues -> Constr Source #

dataTypeOf :: GCValues -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c GCValues) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c GCValues) Source #

gmapT :: (forall b. Data b => b -> b) -> GCValues -> GCValues Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> GCValues -> r Source #

gmapQr :: (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> GCValues -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> GCValues -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> GCValues -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> GCValues -> m GCValues Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> GCValues -> m GCValues Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> GCValues -> m GCValues Source #

Ord GCValues Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods compare :: GCValues -> GCValues -> Ordering Source # (<) :: GCValues -> GCValues -> Bool Source # (<=) :: GCValues -> GCValues -> Bool Source # (>) :: GCValues -> GCValues -> Bool Source # (>=) :: GCValues -> GCValues -> Bool Source # max :: GCValues -> GCValues -> GCValues Source # min :: GCValues -> GCValues -> GCValues Source #
Show GCValues Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods showsPrec :: Int -> GCValues -> ShowS Source # show :: GCValues -> String Source # showList :: [GCValues] -> ShowS Source #

data SetWindowAttributes Source #

pointer to an X11 `XSetWindowAttributes` structure

Instances

Eq SetWindowAttributes Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods (==) :: SetWindowAttributes -> SetWindowAttributes -> Bool Source # (/=) :: SetWindowAttributes -> SetWindowAttributes -> Bool Source #
Data SetWindowAttributes Source # |

Instance details

Defined in Graphics.X11.Xlib.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> SetWindowAttributes -> c SetWindowAttributes Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c SetWindowAttributes Source #

toConstr :: SetWindowAttributes -> Constr Source #

dataTypeOf :: SetWindowAttributes -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c SetWindowAttributes) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c SetWindowAttributes) Source #

gmapT :: (forall b. Data b => b -> b) -> SetWindowAttributes -> SetWindowAttributes Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> SetWindowAttributes -> r Source #

gmapQr :: (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> SetWindowAttributes -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> SetWindowAttributes -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> SetWindowAttributes -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> SetWindowAttributes -> m SetWindowAttributes Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> SetWindowAttributes -> m SetWindowAttributes Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> SetWindowAttributes -> m SetWindowAttributes Source #

Ord SetWindowAttributes Source # |

Instance details

Defined in Graphics.X11.Xlib.Types

Methods

compare :: SetWindowAttributes -> SetWindowAttributes -> Ordering Source #

(<) :: SetWindowAttributes -> SetWindowAttributes -> Bool Source #

(<=) :: SetWindowAttributes -> SetWindowAttributes -> Bool Source #

(>) :: SetWindowAttributes -> SetWindowAttributes -> Bool Source #

(>=) :: SetWindowAttributes -> SetWindowAttributes -> Bool Source #

max :: SetWindowAttributes -> SetWindowAttributes -> SetWindowAttributes Source #

min :: SetWindowAttributes -> SetWindowAttributes -> SetWindowAttributes Source #

Show SetWindowAttributes Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods showsPrec :: Int -> SetWindowAttributes -> ShowS Source # show :: SetWindowAttributes -> String Source # showList :: [SetWindowAttributes] -> ShowS Source #

data VisualInfo Source #

counterpart of an X11 `XVisualInfo` structure

Constructors

VisualInfo |

Fields

- visualInfo_visual :: Visual
- visualInfo_visualID :: VisualID
- visualInfo_screen :: ScreenNumber
- visualInfo_depth :: CInt
- visualInfo_class :: CInt
- visualInfo_redMask :: CULong
- visualInfo_greenMask :: CULong
- visualInfo_blueMask :: CULong
- visualInfo_colormapSize :: CInt
- visualInfo_bitsPerRGB :: CInt

Instances

Eq VisualInfo Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods (==) :: VisualInfo -> VisualInfo -> Bool Source # (/=) :: VisualInfo -> VisualInfo -> Bool Source #
Show VisualInfo Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods showsPrec :: Int -> VisualInfo -> ShowS Source # show :: VisualInfo -> String Source # showList :: [VisualInfo] -> ShowS Source #
Storable VisualInfo Source # |

Instance details

Defined in Graphics.X11.Xlib.Types

Methods

sizeOf :: VisualInfo -> Int Source #

alignment :: VisualInfo -> Int Source #

peekElemOff :: Ptr VisualInfo -> Int -> IO VisualInfo Source #

pokeElemOff :: Ptr VisualInfo -> Int -> VisualInfo -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO VisualInfo Source #

pokeByteOff :: Ptr b -> Int -> VisualInfo -> IO () Source #

peek :: Ptr VisualInfo -> IO VisualInfo Source #

poke :: Ptr VisualInfo -> VisualInfo -> IO () Source #

Default VisualInfo Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods def :: VisualInfo #

newtype Image Source #

pointer to an X11 `XImage` structure

Constructors

Image (Ptr Image) |

Instances

Eq Image Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods (==) :: Image -> Image -> Bool Source # (/=) :: Image -> Image -> Bool Source #
Data Image Source # |

Instance details

Defined in Graphics.X11.Xlib.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> Image -> c Image Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c Image Source #

toConstr :: Image -> Constr Source #

dataTypeOf :: Image -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c Image) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c Image) Source #

gmapT :: (forall b. Data b => b -> b) -> Image -> Image Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> Image -> r Source #

gmapQr :: (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> Image -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> Image -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> Image -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> Image -> m Image Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> Image -> m Image Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> Image -> m Image Source #

Ord Image Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods compare :: Image -> Image -> Ordering Source # (<) :: Image -> Image -> Bool Source # (<=) :: Image -> Image -> Bool Source # (>) :: Image -> Image -> Bool Source # (>=) :: Image -> Image -> Bool Source # max :: Image -> Image -> Image Source # min :: Image -> Image -> Image Source #
Show Image Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods showsPrec :: Int -> Image -> ShowS Source # show :: Image -> String Source # showList :: [Image] -> ShowS Source #

data Point Source #

counterpart of an X11 `XPoint` structure

Constructors

Point |

Fields

- pt_x :: !Position
- pt_y :: !Position

Instances

Eq Point Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods (==) :: Point -> Point -> Bool Source # (/=) :: Point -> Point -> Bool Source #
Data Point Source # |

Instance details

Defined in Graphics.X11.Xlib.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> Point -> c Point Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c Point Source #

toConstr :: Point -> Constr Source #

dataTypeOf :: Point -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c Point) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c Point) Source #

gmapT :: (forall b. Data b => b -> b) -> Point -> Point Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> Point -> r Source #

gmapQr :: (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> Point -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> Point -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> Point -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> Point -> m Point Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> Point -> m Point Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> Point -> m Point Source #

Show Point Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods showsPrec :: Int -> Point -> ShowS Source # show :: Point -> String Source # showList :: [Point] -> ShowS Source #
Storable Point Source # |

Instance details

Defined in Graphics.X11.Xlib.Types

Methods

sizeOf :: Point -> Int Source #

alignment :: Point -> Int Source #

peekElemOff :: Ptr Point -> Int -> IO Point Source #

pokeElemOff :: Ptr Point -> Int -> Point -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Point Source #

pokeByteOff :: Ptr b -> Int -> Point -> IO () Source #

peek :: Ptr Point -> IO Point Source #

poke :: Ptr Point -> Point -> IO () Source #

data Rectangle Source #

counterpart of an X11 `XRectangle` structure

Constructors

Rectangle |

Fields

- rect_x :: !Position
- rect_y :: !Position
- rect_width :: !Dimension
- rect_height :: !Dimension

Instances

Eq Rectangle Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods (==) :: Rectangle -> Rectangle -> Bool Source # (/=) :: Rectangle -> Rectangle -> Bool Source #
Data Rectangle Source # |

Instance details

Defined in Graphics.X11.Xlib.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> Rectangle -> c Rectangle Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c Rectangle Source #

toConstr :: Rectangle -> Constr Source #

dataTypeOf :: Rectangle -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c Rectangle) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c Rectangle) Source #

gmapT :: (forall b. Data b => b -> b) -> Rectangle -> Rectangle Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> Rectangle -> r Source #

gmapQr :: (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> Rectangle -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> Rectangle -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> Rectangle -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> Rectangle -> m Rectangle Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> Rectangle -> m Rectangle Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> Rectangle -> m Rectangle Source #

Read Rectangle Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods readsPrec :: Int -> ReadS Rectangle Source # readList :: ReadS [Rectangle] Source # readPrec :: ReadPrec Rectangle Source # readListPrec :: ReadPrec [Rectangle] Source #
Show Rectangle Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods showsPrec :: Int -> Rectangle -> ShowS Source # show :: Rectangle -> String Source # showList :: [Rectangle] -> ShowS Source #
Storable Rectangle Source # |

Instance details

Defined in Graphics.X11.Xlib.Types

Methods

sizeOf :: Rectangle -> Int Source #

alignment :: Rectangle -> Int Source #

peekElemOff :: Ptr Rectangle -> Int -> IO Rectangle Source #

pokeElemOff :: Ptr Rectangle -> Int -> Rectangle -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Rectangle Source #

pokeByteOff :: Ptr b -> Int -> Rectangle -> IO () Source #

peek :: Ptr Rectangle -> IO Rectangle Source #

poke :: Ptr Rectangle -> Rectangle -> IO () Source #

data Arc Source #

counterpart of an X11 `XArc` structure

Constructors

Arc |

Fields

- arc_x :: Position
- arc_y :: Position
- arc_width :: Dimension
- arc_height :: Dimension
- arc_angle1 :: Angle
- arc_angle2 :: Angle

Instances

Eq Arc Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods (==) :: Arc -> Arc -> Bool Source # (/=) :: Arc -> Arc -> Bool Source #
Show Arc Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods showsPrec :: Int -> Arc -> ShowS Source # show :: Arc -> String Source # showList :: [Arc] -> ShowS Source #
Storable Arc Source # |

Instance details

Defined in Graphics.X11.Xlib.Types

Methods

sizeOf :: Arc -> Int Source #

alignment :: Arc -> Int Source #

peekElemOff :: Ptr Arc -> Int -> IO Arc Source #

pokeElemOff :: Ptr Arc -> Int -> Arc -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Arc Source #

pokeByteOff :: Ptr b -> Int -> Arc -> IO () Source #

peek :: Ptr Arc -> IO Arc Source #

poke :: Ptr Arc -> Arc -> IO () Source #

data Segment Source #

counterpart of an X11 `XSegment` structure

Constructors

Segment |

Fields

- seg_x1 :: Position
- seg_y1 :: Position
- seg_x2 :: Position
- seg_y2 :: Position

Instances

Eq Segment Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods (==) :: Segment -> Segment -> Bool Source # (/=) :: Segment -> Segment -> Bool Source #
Data Segment Source # |

Instance details

Defined in Graphics.X11.Xlib.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> Segment -> c Segment Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c Segment Source #

toConstr :: Segment -> Constr Source #

dataTypeOf :: Segment -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c Segment) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c Segment) Source #

gmapT :: (forall b. Data b => b -> b) -> Segment -> Segment Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> Segment -> r Source #

gmapQr :: (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> Segment -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> Segment -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> Segment -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> Segment -> m Segment Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> Segment -> m Segment Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> Segment -> m Segment Source #

Show Segment Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods showsPrec :: Int -> Segment -> ShowS Source # show :: Segment -> String Source # showList :: [Segment] -> ShowS Source #
Storable Segment Source # |

Instance details

Defined in Graphics.X11.Xlib.Types

Methods

sizeOf :: Segment -> Int Source #

alignment :: Segment -> Int Source #

peekElemOff :: Ptr Segment -> Int -> IO Segment Source #

pokeElemOff :: Ptr Segment -> Int -> Segment -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Segment Source #

pokeByteOff :: Ptr b -> Int -> Segment -> IO () Source #

peek :: Ptr Segment -> IO Segment Source #

poke :: Ptr Segment -> Segment -> IO () Source #

data Color Source #

counterpart of an X11 `XColor` structure

Constructors

Color |

Fields

- color_pixel :: Pixel
- color_red :: Word16
- color_green :: Word16
- color_blue :: Word16
- color_flags :: Word8

Instances

Eq Color Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods (==) :: Color -> Color -> Bool Source # (/=) :: Color -> Color -> Bool Source #
Data Color Source # |

Instance details

Defined in Graphics.X11.Xlib.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> Color -> c Color Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c Color Source #

toConstr :: Color -> Constr Source #

dataTypeOf :: Color -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c Color) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c Color) Source #

gmapT :: (forall b. Data b => b -> b) -> Color -> Color Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> Color -> r Source #

gmapQr :: (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> Color -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> Color -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> Color -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> Color -> m Color Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> Color -> m Color Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> Color -> m Color Source #

Show Color Source # |
Instance details Defined in Graphics.X11.Xlib.Types Methods showsPrec :: Int -> Color -> ShowS Source # show :: Color -> String Source # showList :: [Color] -> ShowS Source #
Storable Color Source # |

Instance details

Defined in Graphics.X11.Xlib.Types

Methods

sizeOf :: Color -> Int Source #

alignment :: Color -> Int Source #

peekElemOff :: Ptr Color -> Int -> IO Color Source #

pokeElemOff :: Ptr Color -> Int -> Color -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Color Source #

pokeByteOff :: Ptr b -> Int -> Color -> IO () Source #

peek :: Ptr Color -> IO Color Source #

poke :: Ptr Color -> Color -> IO () Source #

type Pixel = Word64 Source #

type Position = Int32 Source #

type Dimension = Word32 Source #

type Angle = CInt Source #

type ScreenNumber = Word32 Source #

type Buffer = CInt Source #